<?
//    -------------------------------------------------------------------------
//    $Id: Loader.php,v 1.4 2002/12/23 11:33:32 jonen Exp $
//    -------------------------------------------------------------------------
//    $Log: Loader.php,v $
//    Revision 1.4  2002/12/23 11:33:32  jonen
//    + minor changes
//
//    Revision 1.3  2002/12/19 06:21:37  joko
//    + loadTemplate
//    + case 'template' for 'function loadComponent'
//
//    Revision 1.2  2002/12/12 21:37:46  joko
//    + fixes: now returning success-/error-status
//
//    Revision 1.1  2002/11/12 05:42:31  joko
//    + initial checkin
//
//    -------------------------------------------------------------------------


class Site_Loader {

  var $site;

  function includeFile($filename, $args = array()) {

    // TODO: try to remove these globals!
    global $site;
    global $site_state;
    //global $uservars;
    global $request;
    global $http_referer;

    global $page_state;

    $this->site->log( get_class($this) . "->includeFile( filename $filename )", LOG_DEBUG);
    $site = &$this->site;
    if (include($filename)) {
     return 1;
    }
    
  }
  
  function loadComponent($name, $type = "", $arguments = array()) {
    $prefix = "";
    $postfix = "";
    $this->site->log( get_class($this) . "->loadComponent( name $name, type $type )", LOG_DEBUG);
    
    // TODO: croak somewhere (STDOUT?, logger?) if unknown type gets used here
    switch ($type) {

      case "handler":
        $prefix = $this->site->config[path][base] . 'core/handler/';
        //$postfix = ".handler.php";
        $postfix = ".php";
        $includefile = "$prefix$name$postfix";
        return $this->includeFile($includefile);
        break;

      case "page":
        $prefix = $this->site->config[path][base] . 'core/pages/';
        $postfix = ".page";
        $includefile = "$prefix$name$postfix";
        return $this->includeFile($includefile, $arguments );
        break;

      case "template":
        // TODO: re-activate this (unset smarty's default directory or handle differently (generic))
        //$prefix = $this->site->config[path][base] . 'core/templates/';
        $prefix = '';
        $postfix = ".html";
        $includefile = "$prefix$name$postfix";
        //return $this->includeFile($includefile);
        return $this->site->template->display($includefile, array( 
          'cache_key' => $arguments[cache_key],
          'interpolate' => $arguments['vars'],
          'return' => $arguments['return']
        ));
        break;
    }
  }
  
  function loadHandler($name) {
    $this->site->log( get_class($this) . "->loadHandler( name $name )", LOG_DEBUG);
    return $this->loadComponent($name, "handler");
  }

  function loadPage($name, $args = array()) {
    $this->site->log( get_class($this) . "->loadPage( name $name )", LOG_DEBUG);
    return $this->loadComponent($name, "page", $args);
  }

  function loadTemplate($name, $template_variables = array(), $cache_key = "") {
    $this->site->log( get_class($this) . "->loadTemplate( name $name cache_key $cache_key )", LOG_DEBUG);
    return $this->loadComponent($name, "template", array( 'cache_key' => $cache_key, 'vars' => $template_variables) );
  }

  function loadClass() {
  }

  function loadBusinessClass() {
  }


  
}
?>