<?
//    -------------------------------------------------------------------------
//    $Id: Request.php,v 1.5 2002/12/19 16:24:52 joko Exp $
//    -------------------------------------------------------------------------
//    $Log: Request.php,v $
//    Revision 1.5  2002/12/19 16:24:52  joko
//    + debugging
//
//    Revision 1.4  2002/12/13 09:18:48  joko
//    + new mechanisms for handling the request: split up into _read and _parse
//    + introduced caching-mechanism
//    + fixed overriding-mechanism
//
//    Revision 1.3  2002/12/13 00:22:27  jonen
//    - removed $site_state vars at cachedRequest
//      changes related to new Session class
//
//    Revision 1.2  2002/12/12 21:39:24  joko
//    + fix to 'cacheThisRequest' - now uses the current one to cache if none is passed
//
//    Revision 1.1  2002/11/12 05:42:31  joko
//    + initial checkin
//
//    -------------------------------------------------------------------------


class Site_Request {

  // site's instance
  var $site;
  
  // to keep some status-information for reading/parsing
  var $meta;
  
  // to keep some lowlevel-information about the request
  var $raw;

  // the read and parsed request - ready for further processing with the Request - object
  var $request;

  function getRequest() {
    $this->site->log( get_class($this) . "->getRequest()", LOG_DEBUG );
    $this->_init();
    return $this->request;
  }

  function _init() {
    if (!$this->meta[read]) {
      $this->_read();
    }
    if (!$this->meta[parse]) {
      $this->_parse();
    }
  }


  function _read() {

//print "_read<br>";

    // shift external arguments from url
      $identifier = $_GET[x];
      $externalpage = $_GET[p];
    // fallback to post
      if (!$identifier) { $identifier = $_POST[x]; }
      
    $this->site->log( get_class($this) . "->_read( identifier $identifier )", LOG_DEBUG );

    // remember raw arguments in object
      $this->raw[identifier] = $identifier;
      $this->raw[externalpage] = $externalpage;
      // TODO: url
      
    $this->meta[read] = 1;
    
  }


  function _parse() {

//print "_parse<br>";

    // generic identifier
    $ident = $this->site->decodeIdentifier($this->raw[identifier]);

//print "ident: $ident<br>";
    
    // get handler for identifier
    //$handler = $this->getHandler($ident);
    $this->site->log( get_class($this) . "->_parse: getHandler( identifier $ident )", LOG_DEBUG );
    $handler = $this->site->getHandler($ident);
//print "handler:<br>" . Dumper($handler) . "<br>";
    $handler[name] = $ident;
    
    // parse action from identifier
    if ($ident && substr($ident, -1) != '/') {
      $action = substr($ident, strrpos($ident, '/') + 1);
    }

    // this is the internal (metadata-)structure of the request-object
    $result = array(
      'raw' => $this->raw,
      'ident' => $ident,
      'handler' => $handler,
      'action' => $action,
    );
    
    $this->request = $result;

    $this->meta[parse] = 1;
    
  }
  
  function getCached() {
    return $this->site->session->get('cachedRequest');
  }
  
  function cacheRequest($request = array()) {
    if (!count($request)) {
      $request = $this->getRequest();
    }
//print Dumper($request);
    $this->site->session->set('cachedRequest', $request);
  }

  function overrideRequestIdentifier($ident) {
    $this->overrideIdentifier($ident);
  }

  function overrideIdentifier($ident) {
    $ident_encoded = $this->site->encodeIdentifier($ident);
    $this->raw[identifier] = $ident_encoded;
    $this->meta[parse] = 0;
  }

  function getIdentifier() {
    $this->_init();
    return $this->request[ident];
  }
  
  function isPage() {
    $this->_init();
    return $this->request[handler][isPage];
  }

}

?>