<?
//    -----------------------------------------------------------------------------
//    $Id: User.php,v 1.8 2002/12/28 01:16:42 jonen Exp $
//    -----------------------------------------------------------------------------
//    $Log: User.php,v $
//    Revision 1.8  2002/12/28 01:16:42  jonen
//    + added clear of $this->state[autologout] at 'hadTimeout()'
//
//    Revision 1.7  2002/12/23 11:32:28  jonen
//    + added inserting of uservars on '_create' to frontend db(needed to login user after create!)
//      + added hard link to page 'pub/register', TODO: move this out here
//
//    Revision 1.6  2002/12/18 22:46:06  jonen
//    + added function 'getUserGuid()'
//       (returns user's 'guid' read from database at function 'login()'  (now))
//    + function '_loadData()' loads user remote now via 'getUserGuid()'
//
//    Revision 1.5  2002/12/12 21:34:32  joko
//    + fix in 'function update': invalidate data only if it's not for caching purposes
//
//    Revision 1.4  2002/12/06 04:10:28  joko
//    + replaced 'xyzCache' through 'xyzProxy'
//
//    Revision 1.3  2002/12/04 07:42:54  jonen
//    + changes according to backend schema change
//
//    Revision 1.2  2002/12/03 16:47:22  joko
//    - function preLogout()
//    + function preLogout($autologout = 0)
//    + function hadTimeout()
//
//    Revision 1.1  2002/11/12 05:42:31  joko
//    + initial checkin
//
//    Revision 1.7  2002/10/29 19:09:53  cvsjoko
//    + function getLastLogin
//    + function getUserId
//
//    Revision 1.6  2002/10/25 11:18:10  cvsmax
//    - removed old functions ('logout', 'create',...)
//    + add function preLogout()	# save user session and unset (session) state
//
//    Revision 1.5  2002/10/22 09:47:48  cvsmax
//    + add new
//      - function create()		# create & save new user-object in session
//      - function _create($attr)	# create & save new user-object in backend
//
//    - purged some very old functions
//
//    Revision 1.4  2002/10/17 03:12:17  cvsmax
//    -(+) cleaned code from old structure
//      + function getPostVar($fieldname)
//
//    Revision 1.3  2002/10/10 02:41:57  cvsjoko
//    + fixed typo
//
//    Revision 1.2  2002/10/10 02:34:33  cvsjoko
//    + new level of data-caching (session and persistant)
//        + function _save()
//        + function save()
//    + handling (storing/caching) of POSTed data
//        + function getPostVars()
//        + function setPostVars()
//    + handy utils
//        + function doDataReady()  cares for ready data to continue working
//        + function refresh()           clears underlying data container and makes data "unready"
//
//    Revision 1.1  2002/10/09 00:40:13  cvsjoko
//    + new
//
//
//    -----------------------------------------------------------------------------

class User {
  
  var $state;
  var $meta;
  
  var $pObject;
  var $data;
  
  
  function User() {

    // attention:
    // this code is only run when your session is _really_ fresh
    if (session_register_safe('userstate')) {
    }

    $this->_loadState();
    $this->meta[logontoken] = 'k&%g2';

    // print dumpVar($_SESSION);

  }

  function _loadState() {
    global $userstate;
    $this->state = $userstate;
  }
  function _saveState() {
    global $userstate;
    $userstate = $this->state;
  }


  function _loadData() {
    $this->pObject = new ProxyObject($this->getUserGuid(), array( remote => 1, classname => "NetPerson", guid => 1) );
    if ($this->getUserGuid()) {
      $this->data = $this->pObject->getAttributes();
    }
    $this->meta[data_ready] = 1;
  }

  function _saveData($newRawData) {

    foreach ($newRawData as $key => $val) {
      //print "$key => $val<br>";
      $this->set($key, $val);
    }

    $this->_save("cache");
    
    //$this->pObject->flushProxy();     // done in "pObject->save"
    
  }
  
  function _save($type = '') {
//print Dumper($this->data);
    $this->pObject->save($this->data, $type);
    // invalidate data only if it's not for caching purposes
    if ($type != 'cache') {
      $this->meta[data_ready] = 0;
    }
  }
  
  function save() {
    $this->_doDataReady();
    $this->_save("commit");
  }
  
  function create() {
   $this->_save();
   $attr = $this->pObject->getAttributes();
   //print DumpVar($attr);
   $this->_create($attr);
  }

  function _create($result) {
    //print "saving to backend: " . dumpVar($result) . "<br>";
    $response = $this->pObject->backend->send('createUser', array('data' => $result) );
    $objectId = $response[oid];
    if($objectId) {
    	connectdb();
    	$guid = $response[guid];
    	$username = $this->get('userData.username');
    	$password = $this->get('userData.password');
    	$sql = "INSERT into td_users VALUES ( '$objectId', '$guid', '', '$username', '$password','' )";
	    $res = send_sql($sql);
	  }
	  else {
	    // TODO: handle this with a generic rpc-debug/pending function
      $site->session->set('register_error', 'rpc_error');
      $site->redirect( getlink('/pub/register/') );
	  }
    //$this->_init($objectId);
  }

  function _getHKR($key) {
    $attr_arr = split('\.', $key);
    $attr_hkr = '["' . join('"]["', $attr_arr) . '"]';
    return $attr_hkr;
  }

  function get($attr) {
    $this->_doDataReady();
    $hkr = $this->_getHKR($attr);
    $evalstr = 'return $this->data' . $hkr . ';';
    $val = eval($evalstr);
    return $val;
  }
  function set($attr, $val) {
    $this->_doDataReady();
    $hkr = $this->_getHKR($attr);
    $evalstr = '$this->data' . $hkr . ' = \'' . $val . '\';';
    eval($evalstr);
  }
  
  function isLoggedOn() {
    if ($this->state[id] && $this->state[status] == $this->meta[logontoken]) {
      return 1;
    }
  }
  

  //===== function userlogin =========================
  function login($user,$passwd) {
	connectdb();
	//$sql = "SELECT * FROM td_users WHERE uname='$user'";
	$sql = "SELECT user_oid, guid, uname, pass FROM td_users WHERE uname='$user'";
	if ($res=send_sql($sql)) {
		$row = mysql_fetch_array($res,MYSQL_ASSOC);
		if (!is_array($row)) { return 0; }
	}
	if ($row[pass] == $passwd) {
      //return $uservars_db;
      // store 1st priority user-data to state
        $this->state[id] = $row[user_oid];
        $this->state[guid] = $row[guid];
        $this->state[status] = $this->meta[logontoken];
        $this->_saveState();
      $this->site->log( get_class($this) . "->login ok", LOG_DEBUG );
      return 1;
    } else { 
      return 0; 
    }
}

  function exists($string) {
	connectdb();
	$sql = "SELECT uname FROM td_users WHERE uname='$string'";
	if ($res=send_sql($sql)) {
		$row = mysql_fetch_array($res,MYSQL_ASSOC);

		if (is_array($row)) {
          return 1;
		}
	}

  }
  

  function update($vars) {
    $this->setPostVars($vars);
//print Dumper($vars);
    $data = $this->_transformInputData($vars);
    $this->_saveData($data);
  }
 
  function _transformInputData(&$uservars) {
    global $def_mapping;
    $mapping_uservars2data = array_flip($def_mapping[data2uservars]);
    foreach ($uservars as $key => $val) {
      $key_target = $mapping_uservars2data[$key];
      if($key_target != '') {
        //print "$key => $key_target: $val<br>";
        $target[$key_target] = $val;
      }
    }
    return $target;
  }

  function logout() {

    global $site;

    // get information about user from site
      $userid = $this->getUserId();

      $this->site->log( get_class($this) . "->logout: userid $userid", LOG_DEBUG );
    
    // get information about session from php
      $session_id = session_id();
      $session_name = session_name();

    // session-sqldb related
      $date = date('Y-m-d H:i:s', time());
      $session_e = $site->session->exists($session_id);
      $sql = "UPDATE f_map_user_session SET date_logged_out='$date' WHERE session_uid='$session_e[session_uid]' AND user_uid='$userid'";
      $res = send_sql($sql);

    // destroy user's session at server-side
      $session_name = session_name();
      session_destroy();

    // overwrite session-variables - to be sure ;)
      $_SESSION = array();
      unset($_COOKIE[$session_name]);

  }

  function preLogout($autologout = 0) {
    global $site;
    $this->state[status] = '';
    $this->state[autologout] = $autologout;
    $this->_saveState();
  }

  function getAccountSum() {
    // store additional user-data to state
      if (!$this->state[accountSum]) {
        $this->state[accountSum] = $this->get("account.amount");
        $this->_saveState();
      }
      return $this->state[accountSum];
  }

  function getAccountCurrency() {
    // store additional user-data to state
      if (!$this->state[accountCurrency]) {
        $this->state[accountCurrency] = $this->get("account.currency");
        $this->_saveState();
      }
      //print "state: " . $this->get("financeInfo.currency") . "<br>";
      return $this->state[accountCurrency];
  }
  
  function refresh() {
    if ($this->pObject) {$this->pObject->flushState();}
    $this->meta[data_ready] = 0;
  }
  
  function _doDataReady() {
    if (!$this->meta[data_ready]) { $this->_loadData(); }
  }

  function getLastLogin() {
    $userid = $this->getUserId();
    connectdb();
    $sql = "SELECT * FROM f_map_user_session WHERE user_uid='$userid' AND last='1'";
    $res = send_sql($sql);
    while($row = mysql_fetch_array($res,MYSQL_BOTH)) {
      if($row[date_logged_out]=="0000-00-00 00:00:00") { 
        $date = $row[date_logged_in];
      } else { 
        $date = $row[date_logged_out];
      }
      $lastLogin = strftime("%d %b %Y - %H:%M",strtotime($date));
    }
    return $lastLogin;
  }
  
  function getUserId() {
    return $this->state[id];
  }

  function getUserGuid() {
    return $this->state[guid];
  }

  function getPostVars() {
    return $this->state[postvars];
  }

  function setPostVars($postvars) {
    $this->state[postvars] = $postvars;
    $this->_saveState();
  }

  function getPostVar($var) {
    return $this->state[postvars][$var];
  }
  
  function hadTimeout() {
    if ($this->state[autologout]) { $this->state[autologout] = ''; return 1; }
  }

}

?>